#!/usr/bin/webif-page
<?

###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

. /usr/lib/webif/webif.sh

sel_mailservice=1

. /usr/lib/webif/advanced.sh


config_save () {
echo "# Configuration written from webif
FromLineOverride=Yes
hostname=${1##*@}
mailhub=$2:$3
AuthUser=$4
AuthPass=$5
" >/etc/ssmtp/ssmtp.conf
}

testmail() {
echo "From: $1
To: $2
Subject: Fonera: Testmessage from your Fonera (Hostname: `cat /etc/hostname`) enhanced with FreeWLAN Addons.
You receive this mail because you send a testmail from the Mail Service configuration page.
`date`
" |ssmtp -d5 -t 2>/tmp/ssmtp_test_$$.log
true;
}

if empty "$FORM_testmailsend"; then
	SEND=0
  else
   validate <<EOF
mail|FORM_to|@TR<<Recipient>>|required|$FORM_to
EOF
   equal "$?" 0  && {
	SEND=1
	FORM_submit="Send";
   }
fi

config_load mailservice
if empty "$FORM_submit"; then
   get_default enable auth enable
   get_default username auth username
   get_default password auth password
   get_default mailserver server mailserver
   get_default port server port
   get_default service_enable mail service_enable
   get_default from mail from
   get_default to mail to
   get_default rebootcheck mail rebootcheck
   get_default fonupdatecheck mail fonupdatecheck
   get_default conalarm mail conalarm
else

   enabled "$FORM_service_enable" && \
   validate <<EOF
string|FORM_mailserver|@TR<<Mailserver>>|required|$FORM_mailserver
string|FORM_from|@TR<<Sender>>|required|$FORM_from
int|FORM_port|@TR<<Port>>|required|$FORM_port
EOF
   equal "$?" 0  && {
      save_setting mailservice server mailserver "$FORM_mailserver"
      save_setting mailservice server port "$FORM_port"
      save_setting mailservice mail service_enable "$FORM_service_enable"
      save_setting mailservice mail enable "$FORM_enable"
      save_setting mailservice mail from "$FORM_from"
      save_setting mailservice mail to "$FORM_to"
      save_setting mailservice mail rebootcheck "$FORM_rebootcheck"
      save_setting mailservice mail fonupdatecheck "$FORM_fonupdatecheck"
      save_setting mailservice mail conalarm "$FORM_conalarm"
      commit_settings
      SAVED=1
   }
   enabled "$FORM_service_enable" || {
      save_setting mailservice mail service_enable "$FORM_service_enable"
      commit_settings
      SAVED=1
   }
   enabled "$FORM_enable" && {
   validate <<EOF
string|FORM_username|@TR<<Username>>|required|$FORM_username
string|FORM_password|@TR<<Password>>|required|$FORM_password
EOF
} 
   equal "$?" 0  && {
      save_setting mailservice auth enable "$FORM_enable"
      save_setting mailservice auth username "$FORM_username"
      save_setting mailservice auth password "$FORM_password"
      save_setting mailservice auth enable "$FORM_enable"
      commit_settings
      SAVED=1
   }
   enabled "$FORM_enable" || {
   FORM_username="";
   FORM_password="";
   save_setting mailservice auth enable "$FORM_enable"
   save_setting mailservice auth username ""
   save_setting mailservice auth password ""
   commit_settings
        SAVED=1
   }
   config_save "$FORM_from" "$FORM_mailserver" "$FORM_port" "$FORM_username" "$FORM_password"
fi

header "Mail Service"

cat <<EOF
<script language="Javascript1.5" type="text/javascript">
<!--
function modechange() {
   set_visible('mode_ssmtp', isset('enable', '1'));
}
function mailchange() {
   set_visible('mode_enable', isset('service_enable', '1'));
}
-->
</script>
EOF

display_form <<EOF
	infotable|Advanced_ssmtp#Here you configure the mail service to send e-mail.
    start_table|0|10|5
      onchange|mailchange
	  add_row
         add_label_cell|@TR<<Mailservice>>
         start_select_cell|service_enable|$FORM_service_enable|tableTextSelect
            option|0|@TR<<Disabled>>
            option|1|@TR<<Enabled>>
         end_select_cell
      end_row
      add_row
         add_button_cell|submit|@TR<<Submit>>|tableTextButton
      end_row
   end_table
   
   
   
   start_div|mode_enable
    start_table|0|10|5
      add_row
         add_label_cell|@TR<<Mail Server>>
         add_input_cell|mailserver|$FORM_mailserver|tableTextButton
      end_row
      add_row
         add_label_cell|@TR<<Port>>
         add_input_cell|port|$FORM_port|tableTextButton
      end_row
      add_row
         add_label_cell|@TR<<Sender>>
         add_input_cell|from|$FORM_from|tableTextButton
      end_row
      add_row
         add_label_cell|@TR<<Recipient>>
         add_input_cell|to|$FORM_to|tableTextButton
      end_row
    end_table
    start_table|0|10|5
      onchange|modechange
	  add_row
         add_label_cell|@TR<<SMTP Authentification>>
         start_select_cell|enable|$FORM_enable|tableTextSelect
            option|0|@TR<<Disabled>>
            option|1|@TR<<Enabled>>
         end_select_cell
      end_row
   end_table
   
   start_div|mode_ssmtp
      start_table|0|10|5
		  add_row
			 add_label_cell|@TR<<Username>>
			 add_input_cell|username|$FORM_username|tableTextButton
		  end_row
		  add_row
			 add_label_cell|@TR<<Password>>
			 add_input_cell|password|$FORM_password|tableTextButton
		  end_row
      end_table
   end_div
   
   start_table|0|10|5
      add_row
         add_button_cell|submit|@TR<<Submit>>|tableTextButton
         add_button_cell|testmailsend|@TR<<Testmail>>|tableTextButton
      end_row
   end_table



	infotable|Advanced_mailservice#Select on which events shall the system send a mail to you.
	start_table|0|10|5
      add_row
		add_label_cell|@TR<<recieve an e-mail>>:
      end_row
      add_row
		add_label_cell|@TR<<after reboot>>
                start_select_cell|rebootcheck|$FORM_rebootcheck|tableTextSelect
                 option|0|@TR<<Disabled>>
                 option|1|@TR<<Enabled>>
                end_select_cell
      end_row
EOF
[ -f /etc/debug ] && {
display_form <<EOF
      add_row
		add_label_cell|@TR<<on FON Updates available>>
                start_select_cell|fonupdatecheck|$FORM_fonupdatecheck|tableTextSelect
                 option|0|@TR<<Disabled>>
                 option|1|@TR<<Enabled>>
                end_select_cell
      end_row
EOF
}
display_form <<EOF
      add_row
		add_label_cell|@TR<<when a user logs in via FON_AP>>
                start_select_cell|conalarm|$FORM_conalarm|tableTextSelect
                 option|0|@TR<<Disabled>>
                 option|1|@TR<<Enabled>>
                end_select_cell
      end_row
      add_row
                add_button_cell|submit|@TR<<Submit>>|tableTextButton
      end_row
   end_table
   end_div
   call_js|modechange
   call_js|mailchange
EOF
if [ "x$SEND" = "x1" ];then
 testmail $FORM_from "$FORM_to";
 echo "<textarea style='width:700px; height:400px'>"
 cat /tmp/ssmtp_test_$$.log
 echo "</textarea>"
 rm /tmp/ssmtp_test_$$.log
fi
footer ?>
