#!/usr/bin/webif-page
<?

###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This Script is based on work from http://www.fonfan.de
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

. /usr/lib/webif/webif.sh

barhigh=5
scale=54

zerofill() {
	[ ${#1} = 1 ] && echo 0$1 || echo $1
}

table_active_connections() {
# $1 = interface
online_file=/tmp/online
tmp=/tmp/wlan_list_$$.tmp;
wlanconfig $1 list 2> /dev/null >$tmp
lines=`wc -l $tmp`;lines=${lines% *}
if [ $lines != 0 ];then
 [ "$1" = "ath0" ] && infohead="add_normal_cell|<b>@TR<<INFO>></b>"
 
 display_form <<EOF
start_table|0|10|5
			add_row
				add_normal_cell|<b>@TR<<MAC>></b>
				add_normal_cell|<b>@TR<<IP>></b>
				add_normal_cell|<b>@TR<<SPEED>></b>
				$infohead
				add_normal_cell|<a href="/cgi-bin/webif/blockmac.sh"><b>@TR<<MAC blocking>></b></a>
			end_row
EOF
		now=`date +%s`; now_min=$((now/60));now_sec=$((now-now_min * 60));
                cat $tmp | grep -v ADDR| while read i
                do
                        mac=`echo $i | awk '{print $1}'|tr a-z A-Z`
                        speed=`echo $i | awk '{print $4}'`
                        sigspeed=${speed%M}
                        [ -z $sigspeed ] && sigspeed=0
                        ip=`cat /proc/net/arp | grep -i $mac | awk '{print $1}'`
			signal=$((100*$sigspeed/54*scale/100))
			[ $signal -gt $scale ] && signal=$scale
                	gray=$((scale-signal))
                	
                	grep -q $mac $online_file 2>/dev/null && online=1 || online=0
                	case "$online" in
                		1) user=`grep $mac $online_file | cut -d" " -f3`
                		   timeout=`grep $mac $online_file | cut -d" " -f4`; timeout_min=$((timeout/60)); timeout_sec=$((timeout-timeout_min * 60));
                		   ip=`grep $mac $online_file | cut -d" " -f2`
                		   since=`grep $mac $online_file | cut -d" " -f5`; since_min=$((since/60)); since_sec=$((since-since_min * 60));
                		   #since=$((now-since))
						   since_sec=$((now_sec-since_sec))
						   test $since_sec -lt 0 && {
								since_sec=$((since_sec + 60))
								since_min=$((since_min - 1))
						   }
						   
						   since_min=$((now_min - since_min))
						   residual="@TR<<unlimited>>"
						   new_timeout_min=0 
						   new_timeout_sec=0 
						   if [ "$timeout" != "0" ]; then
								new_timeout_sec=$((timeout_sec - $since_sec))
								test $new_timeout_sec -lt 0 && {
									new_timeout_sec=$((new_timeout_sec + 60))
									new_timeout_min=$((new_timeout_min - 1))
								}
								new_timeout_min=$((timeout_min - since_min))
								residual="$((new_timeout_min)):$(zerofill $new_timeout_sec)min"
						   fi
						   
						   since_title=" @TR<<online since>>: $((since_min)):$(zerofill $since_sec)min"
						   residual_tilte=" @TR<<residual>>: $residual"

        				   if [ "$timeout" = "0" ]; then
								img="<a class=\"infobox\" href=\"#\"><img border=0 src=\"/images/linus-bill.gif\" alt=\"$user\"><span><b>Linus/Bill:</b><br /> @TR<<Username>>: $user <br /> $since_title <br /> $residual_tilte </span></a>";
						   else
								img="<a class=\"infobox\" href=\"#\"><img border=0 src=\"/images/alien.gif\" alt=\"$user\"><span><b>Alien:</b><br /> @TR<<Username>>: $user <br /> $since_title <br /> $residual_tilte </span></a>";
						   fi
                		;;
                		0) user=""
                		   img="<a class=\"infobox\" href=\"#\"><img border=0 src=\"/images/logged_off.gif\" alt=\"@TR<<not authenticated>>\"><span><b>@TR<<Unknown>>:</b><br /> @TR<<not authenticated>> </span></a>";
                		;;
                	esac;
			[ "$1" = "ath0" ] && infocell="add_normal_cell|$img"
display_form <<EOF
                add_row
                        add_normal_cell|$mac
                        add_normal_cell|$ip
			add_normal_cell|<img src="/images/a.gif" height="$barhigh" width="$signal" alt="$speed" title="$speed"><img src="/images/gray.gif" height="$barhigh" width="$gray" alt="$speed" title="$speed">
                        $infocell
                        add_normal_cell|<a href="/cgi-bin/webif/line_add_del.sh?ACTION=macblock&ADDDEL=1&CONTENT=$mac">@TR<<block now>></a>
                end_row
EOF
                done
display_form <<EOF
end_table
EOF
 else
display_form <<EOF
start_table|0|10|5
                add_row
                        add_normal_cell|@TR<<None>>
                        add_normal_cell|<a href="/cgi-bin/webif/blockmac.sh">(MAC blocking)</a>
                end_row
end_table
EOF
fi
rm $tmp
}


config_load fon
config_get mode wan mode
config_get ssid piblic ssid
config_get rssid wan rssid
config_get dhcpname wan dhcpname

. /tmp/network-config

get_default wanmode wan mode
case "$FORM_wanmode" in
	static)
		wanmode="Static"
	;;
	dhcp)
		wanmode="DHCP"
	;;
	pppoe)
		wanmode="PPPoE"
	;;
	pptp)
		wanmode="PPTP"
	;;
	wlan)
		wanmode="WLAN"
	;;
	*) wanmode="Unknown"
	;;
esac

config_get pubssid public essid
config_get privssid private essid
config_get encryption private encryption
config_get priv_hidden private hidden

if [ "$priv_hidden" = "1" ]; then
	priv_hidden="<span style=\"color: green\">@TR<<Hidden>></span>"
else
	priv_hidden=""
fi

wan_gw="$(route -n | grep '^0.0.0.0' | awk '{print $2}')"
for ns in $(grep nameserver /etc/resolv.conf | awk '{print $2}'); do
	wan_ns="${wan_ns:+$wan_ns, }$ns"
done

version="$(cat /etc/fon_version) r$(cat /etc/fon_revision)"
addonversion="$(cat /etc/addon_version)"


header "Router Status - Freewlan Addons $addonversion"


priv_ip="$(ifconfig $lanif 2>/dev/null | grep inet | awk -F'[: ]+' '{print $4}')"
case "$mode" in
	*)
		config_get bridge wan bridge
		[ "$bridge" = "0" ] && lanif=ath1 || lanif=br0
		pub_mac="$(ifconfig ath0 2>/dev/null | grep HWaddr | awk -F'[ ]+' '{print $5}')"
		priv_mac="$(ifconfig ath1 2>/dev/null | grep HWaddr | awk -F'[ ]+' '{print $5}')"
		wan_mac="$(ifconfig eth0 2>/dev/null | grep HWaddr | awk -F'[ ]+' '{print $5}')"
		wan_ip="$(ifconfig "${wan_ifname:-eth0}" 2>/dev/null | grep inet | awk -F'[: ]+' '{print $4}')"
		[ "$bridge" = "1" ] && priv_ip="$priv_ip (Bridge)"
	;;
	"wlan")
		ath2_pwr="$(iwconfig ath2 2>/dev/null | grep Bit | awk 'FS=":" {print $2}' | awk '{print $1}')" 
		 [ -z $ath2_pwr ] && $ath2_pwr=0
		 speed=$((100*$ath2_pwr/54))
		 [ $speed -gt $scale ] && speed=$scale
		 gray=$((scale-speed))
		lanif=ath1
		pub_mac="$(ifconfig ath0 2>/dev/null | grep HWaddr | awk -F'[ ]+' '{print $5}')"
		bridge_ip="$(ifconfig ath2 2>/dev/null | grep inet | awk -F'[: ]+' '{print $4}')"
	;;
esac

display_form <<EOF
start_table|0|10|5
	add_row
		add_label_cell
		add_button_cell|submit|@TR<<Reload Status Page>>|tableTextButton
	end_row
end_table
start_table|0|10|5
	add_row
		add_title_cell|@TR<<Status_Conn_Priv#Active connections on the private WLAN>>	
	end_row
end_table
EOF

table_active_connections ath1

display_form <<EOF
start_table|0|10|5
	add_row
		add_title_cell|@TR<<Status_Conn_Pub#Active connections on the public WLAN>>
	end_row
end_table
EOF

table_active_connections ath0

display_form <<EOF
start_table|0|10|5
	add_row
		add_title_cell|@TR<<System>>
	end_row
	add_row
		add_label_cell|@TR<<Firmware Version>>
		add_label_cell|$version
	end_row
	add_row
		add_label_cell|@TR<<Addon Version>>
		add_label_cell|$addonversion
	end_row
end_table
start_table|0|10|5
	add_row
		add_title_cell|@TR<<Internet connection>>
	end_row
	add_row
		add_label_cell|@TR<<Connection type>>
		add_label_cell|$wanmode
	end_row
EOF
	
case $mode in
	*)
		display_form <<EOF
			add_row
				add_label_cell|@TR<<MAC Address>>
				add_label_cell|$wan_mac
			end_row
			add_row
				add_label_cell|@TR<<IP Address>>
				add_label_cell|${wan_ip:-N/A}
			end_row
			add_row
				add_label_cell|@TR<<Gateway Address>>
				add_label_cell|${wan_gw:-N/A}
			end_row
			add_row
				add_label_cell|@TR<<DNS Server>>
				add_label_cell|${wan_ns:-N/A}
			end_row
EOF
	;;
	"wlan")
		display_form <<EOF
			add_row
				add_label_cell|@TR<<Remote SSID>>
				add_label_cell|$rssid
			end_row
			add_row
				add_label_cell|@TR<<Speed>>
				add_normal_cell|<img src="/images/a.gif" height="$barhigh" width="$speed" alt="${speed}M" title="${speed}M"><img src="/images/gray.gif" height="$barhigh" width="$gray" alt="${speed}M" title="${speed}M">
			end_row
			add_row
				add_label_cell|@TR<<IP Address>>
				add_label_cell|${bridge_ip:-N/A}
			end_row
			add_row
				add_label_cell|@TR<<Gateway Address>>
				add_label_cell|${wan_gw:-N/A}
			end_row
			add_row
				add_label_cell|@TR<<DNS Server>>
				add_label_cell|${wan_ns:-N/A}
			end_row
			add_row
				add_label_cell|@TR<<DHCP Hostname>>
				add_label_cell|$dhcpname
			end_row
EOF
	;;
esac

display_form <<EOF
end_table
start_table|0|10|5
	add_row
		add_title_cell|@TR<<WiFi Settings>>
	end_row
	add_row
		add_label_cell|@TR<<Public SSID>>
		add_label_cell|FON_$pubssid
	end_row
	add_row
		add_label_cell|@TR<<Public MAC>>
		add_label_cell|$pub_mac
	end_row
end_table
start_table|0|10|5
	add_row
		add_label_cell|@TR<<Private SSID>>
		add_label_cell|$privssid $priv_hidden
	end_row
	add_row
		add_label_cell|@TR<<Encryption>>
		add_label_cell|${encryption:-none}
	end_row
	add_row
		add_label_cell|@TR<<IP Address>>
		add_label_cell|${priv_ip:-N/A}
	end_row
end_table
EOF

if [ "$mode" = "wlan" ]; then
	display_form <<EOF
		start_table|0|10|5
			add_row
				add_title_cell|@TR<<Scan>>
				add_label_cell|<a href="/cgi-bin/webif/scan.sh" rel="lyteframe" rev="width: 690px; height: 585px">@TR<<display detailed site survey>></a>
			end_row
		end_table
		start_table|0|10|5
			add_row
				add_normal_cell|<b>SSID</b>
				add_normal_cell|<b>SIGNAL</b>
				add_normal_cell|<b>BSSID</b>
				add_normal_cell|<b>CHAN</b>
			end_row
EOF

wlanconfig ath0 list ap 2>/dev/null|grep -v ^SSID|while read line;do
		ssid=`echo "$line"|cut -d":" -f1`
		ssid=${ssid%% 00:*} #fix ssid with spaces
		ssid=${ssid%%00}
		line=${line##$ssid}
		bssid=`echo $line|cut -d" " -f1`
		chan=`echo $line|cut -d" " -f2`
		signal=`echo $line|cut -d" " -f4|cut -d":" -f1`
		[ $signal -lt 1 ] && signal=0
		osignal=$((100*$signal/98))
		[ $osignal -gt 100 ] && osignal=100
		signal=$((100*$signal/98*scale/100))
		[ $signal -gt $scale ] && signal=$scale
		gray=$(($scale-signal))
display_form <<EOF
		add_row
			add_normal_cell|$ssid
			add_normal_cell|<img src="/images/a.gif" height="$barhigh" width="$signal" alt="$osignal" title="$osignal"></img><img src="/images/gray.gif" height="$barhigh" width="$gray" alt="$osignal" title="$osignal"></img>
			add_normal_cell|$bssid
			add_normal_cell|$chan
		end_row
EOF

done

display_form <<EOF
	end_table
	start_table|0|10|5
	add_row
		add_label_cell
		add_button_cell|submit|@TR<<Reload Status Page>>|tableTextButton
	end_row
end_table
EOF
fi

footer

?>
